Index: trunk/kBuild/tools/VCC80.kmk
===================================================================
--- trunk/kBuild/tools/VCC80.kmk	(revision 1289)
+++ trunk/kBuild/tools/VCC80.kmk	(revision 1295)
@@ -264,7 +264,12 @@
 		$(subst /,\\,$(objs)) \
 		$(subst /,\\,$(libs))
+ifdef KMK_USE_TEST
+	$(QUIET)$(TEST) -f $(out).manifest -- \
+		$(TOOL_VCC80_MT) -manifest $(subst /,\\,$(out)).manifest -outputresource:$(subst /,\\,$(out))
+else
 	$(QUIET)if test -f $(out).manifest; then \
 		$(TOOL_VCC80_MT) -manifest $(subst /,\\,$(out)).manifest -outputresource:$(subst /,\\,$(out)); \
 	fi
+endif
 endef
 
@@ -300,7 +305,12 @@
 		$(subst /,\\,$(objs)) \
 		$(subst /,\\,$(libs))
+ifdef KMK_USE_TEST
+	$(QUIET)$(TEST) -f $(out).manifest -- \
+		$(TOOL_VCC80_MT) -manifest $(subst /,\\,$(out)).manifest "-outputresource:$(subst /,\\,$(out));#2"
+else
 	$(QUIET)if test -f $(out).manifest; then \
 		$(TOOL_VCC80_MT) -manifest $(subst /,\\,$(out)).manifest "-outputresource:$(subst /,\\,$(out));#2"; \
 	fi
+endif
 ifeq ($(filter %.exp .def,$(othersrc)),)
 ifdef KMK_NEW_CP
@@ -343,7 +353,12 @@
 		$(subst /,\\,$(objs)) \
 		$(subst /,\\,$(libs))
+ifdef KMK_USE_TEST
+	$(QUIET)$(TEST) -f $(out).manifest -- \
+		$(TOOL_VCC80_MT) -manifest $(subst /,\\,$(out)).manifest "-outputresource:$(subst /,\\,$(out));#2";
+else
 	$(QUIET)if test -f $(out).manifest; then \
 		$(TOOL_VCC80_MT) -manifest $(subst /,\\,$(out)).manifest "-outputresource:$(subst /,\\,$(out));#2"; \
 	fi
-endef
-
+endif
+endef
+
Index: trunk/kBuild/tools/VCC80AMD64.kmk
===================================================================
--- trunk/kBuild/tools/VCC80AMD64.kmk	(revision 1289)
+++ trunk/kBuild/tools/VCC80AMD64.kmk	(revision 1295)
@@ -241,7 +241,12 @@
 		$(subst /,\\,$(objs)) \
 		$(subst /,\\,$(libs))
+ifdef KMK_USE_TEST
+	$(QUIET)$(TEST) -f $(out).manifest -- \
+		$(TOOL_VCC80AMD64_MT) -manifest $(subst /,\\,$(out)).manifest -outputresource:$(subst /,\\,$(out))
+else
 	$(QUIET)if test -f $(out).manifest; then \
 		$(TOOL_VCC80AMD64_MT) -manifest $(subst /,\\,$(out)).manifest -outputresource:$(subst /,\\,$(out)); \
 	fi
+endif
 endef
 
@@ -277,7 +282,12 @@
 		$(subst /,\\,$(objs)) \
 		$(subst /,\\,$(libs))
+ifdef KMK_USE_TEST
+	$(QUIET)$(TEST) -f $(out).manifest -- \
+		$(TOOL_VCC80AMD64_MT) -manifest $(subst /,\\,$(out)).manifest "-outputresource:$(subst /,\\,$(out));#2"
+else
 	$(QUIET)if test -f $(out).manifest; then \
 		$(TOOL_VCC80AMD64_MT) -manifest $(subst /,\\,$(out)).manifest "-outputresource:$(subst /,\\,$(out));#2"; \
 	fi
+endif
 ifeq ($(filter %.exp .def,$(othersrc)),)
 ifdef KMK_NEW_CP
@@ -320,7 +330,12 @@
 		$(subst /,\\,$(objs)) \
 		$(subst /,\\,$(libs))
+ifdef KMK_USE_TEST
+	$(QUIET)$(TEST) -f $(out).manifest -- \
+		$(TOOL_VCC80AMD64_MT) -manifest $(subst /,\\,$(out)).manifest "-outputresource:$(subst /,\\,$(out));#2"
+else
 	$(QUIET)if test -f $(out).manifest; then \
 		$(TOOL_VCC80AMD64_MT) -manifest $(subst /,\\,$(out)).manifest "-outputresource:$(subst /,\\,$(out));#2"; \
 	fi
-endef
-
+endif
+endef
+
Index: trunk/kBuild/tools/VCC80X86.kmk
===================================================================
--- trunk/kBuild/tools/VCC80X86.kmk	(revision 1289)
+++ trunk/kBuild/tools/VCC80X86.kmk	(revision 1295)
@@ -243,7 +243,12 @@
 		$(subst /,\\,$(objs)) \
 		$(subst /,\\,$(libs))
+ifdef KMK_USE_TEST
+	$(QUIET)$(TEST) -f $(out).manifest -- \
+		$(TOOL_VCC80X86_MT) -manifest $(subst /,\\,$(out)).manifest -outputresource:$(subst /,\\,$(out))
+else
 	$(QUIET)if test -f $(out).manifest; then \
 		$(TOOL_VCC80X86_MT) -manifest $(subst /,\\,$(out)).manifest -outputresource:$(subst /,\\,$(out)); \
 	fi
+endif
 endef
 
@@ -279,7 +284,12 @@
 		$(subst /,\\,$(objs)) \
 		$(subst /,\\,$(libs))
+ifdef KMK_USE_TEST
+	$(QUIET)$(TEST) -f $(out).manifest -- \
+		$(TOOL_VCC80X86_MT) -manifest $(subst /,\\,$(out)).manifest "-outputresource:$(subst /,\\,$(out));#2"
+else
 	$(QUIET)if test -f $(out).manifest; then \
 		$(TOOL_VCC80X86_MT) -manifest $(subst /,\\,$(out)).manifest "-outputresource:$(subst /,\\,$(out));#2"; \
 	fi
+endif
 ifeq ($(filter %.exp .def,$(othersrc)),)
 ifdef KMK_NEW_CP
@@ -322,7 +332,12 @@
 		$(subst /,\\,$(objs)) \
 		$(subst /,\\,$(libs))
+ifdef KMK_USE_TEST
+	$(QUIET)$(TEST) -f $(out).manifest -- \
+		$(TOOL_VCC80X86_MT) -manifest $(subst /,\\,$(out)).manifest "-outputresource:$(subst /,\\,$(out));#2"
+else
 	$(QUIET)if test -f $(out).manifest; then \
 		$(TOOL_VCC80X86_MT) -manifest $(subst /,\\,$(out)).manifest "-outputresource:$(subst /,\\,$(out));#2"; \
 	fi
-endef
-
+endif
+endef
+